const { pick } = require("lodash");
const { setValue } = require("../asyncLocalStorage/asyncLocalStorageNamespace");
const { LAMBDA_REQUEST_CONTEXT } = require("../constants/commonConstants");
const lambdaContextProperties = require("../constants/lambdaContextProperties");

/**
 * A utility method to set the lambda context into async local storage namespace
 * @param awsRequestId
 */
const setLambdaContext = (lambdaRequestContext) => {
  return asyncLocalStorageNamespace.run(() => {
    //https://docs.aws.amazon.com/lambda/latest/dg/nodejs-context.html
    const context = pick(
      lambdaRequestContext,
      Object.values(lambdaContextProperties)
    );

    asyncLocalStorageNamespace.setValue(LAMBDA_REQUEST_CONTEXT, context);
  });
};

module.exports = setLambdaContext;
